#include <stdint.h>

/* http://en.wikipedia.org/wiki/Adler-32 */

const uint32_t MOD_ADLER = 65521;

/* where data is the location of the data in physical memory and len is the length of the data in bytes */
uint32_t adler32(unsigned char *data, uint32_t len) {
	uint32_t a = 1, b = 0;
	uint32_t index;

	/* Process each byte of the data in order */
	for (index = 0; index < len; ++index)
	{
		a = (a + data[index]) % MOD_ADLER;
		b = (b + a) % MOD_ADLER;
	}

	return (b << 16) | a;
}
