#include <libdragon.h>
#include <mikmod.h>
//#include <memory.h>

/***** N64-libdragon driver *****/
static short *mdn64_buf = NULL;
static int mdn64_bufsize;

static BOOL N64_IsThere(void)
{
	return 1;
}

static int N64_Init(void)
{
	mdn64_bufsize = audio_get_buffer_length() * 2/*ch*/ * sizeof(short)/*byte/ch*/;
	mdn64_buf = (short*)MikMod_malloc(mdn64_bufsize);
	return VC_Init();
}

static void N64_Exit(void)
{
	VC_Exit();
	MikMod_free(mdn64_buf);
	mdn64_buf = NULL;
}

static void N64_Update(void)
{
	if (mdn64_buf) {
		VC_WriteBytes((SBYTE*)mdn64_buf, mdn64_bufsize);
		audio_write(mdn64_buf);
	}
}

MIKMODAPI MDRIVER drv_n64 = {
	NULL,
	"n64", // name
	"n64 libdragon driver v.0", // version
	255, 255, // hard/soft voice limit
	"n64dragon", // alias
	NULL, // cmdline-help
	NULL, // CommandLine
	N64_IsThere,
	VC_SampleLoad,
	VC_SampleUnload,
	VC_SampleSpace,
	VC_SampleLength,
	N64_Init,
	N64_Exit,
	NULL, // Reset
	VC_SetNumVoices,
	VC_PlayStart,
	VC_PlayStop,
	N64_Update,
	NULL, // Pause
	VC_VoiceSetVolume,
	VC_VoiceGetVolume,
	VC_VoiceSetFrequency,
	VC_VoiceGetFrequency,
	VC_VoiceSetPanning,
	VC_VoiceGetPanning,
	VC_VoicePlay,
	VC_VoiceStop,
	VC_VoiceStopped,
	VC_VoiceGetPosition,
	VC_VoiceRealVolume
};
