#ifndef __SRAM_H
#define __SRAM_H

#ifdef __cplusplus
extern "C" {
#endif

void save_init();
/* note: checksum is written at last 4 bytes, so usable area is pagesize-4 bytes length. */
/* note2: pagesize are aligned by 8bytes. */
void save_pagesize(uint32_t pagesize);
void save_pagecopy(uint32_t pagecopy);
/* uint32_t should be bool. */
/* note: content of buf is destroyed even when read fails (i.e. bad checksum). */
uint32_t save_read(void *buf);
/* uint32_t should be bool. */
/* note: last 4 bytes of buf are overwritten by checksum. */
/* note2: save_write does not verify, it requires additional buffer. */
uint32_t save_write(void *buf);

#ifdef __cplusplus
}
#endif

#endif
